﻿unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, YUVConverts, StdCtrls, JPeg;

const
  WM_CAP_START = WM_USER;
  WM_CAP_DRIVER_CONNECT = WM_CAP_START + 10;

  WM_CAP_SET_PREVIEW = WM_CAP_START + 50;
  WM_CAP_SET_OVERLAY = WM_CAP_START + 51;
  WM_CAP_SET_PREVIEWRATE = WM_CAP_START + 52;

  WM_CAP_GRAB_FRAME_NOSTOP = WM_CAP_START + 61;
  WM_CAP_SET_CALLBACK_FRAME = WM_CAP_START + 5;
  WM_CAP_GET_VIDEOFORMAT = WM_CAP_START + 44;

  WM_CAP_DLG_VIDEOFORMAT = WM_CAP_START + 41;

  PICWIDTH = 640;
  PICHEIGHT = 480;
  SUBLINEHEIGHT = 18;
  EXTRAHEIGHT = 400;

type
  TVIDEOHDR = record
    lpData: Pointer; // address of video buffer
    dwBufferLength: DWord; // size, in bytes, of the Data buffer
    dwBytesUsed: DWord; // see below
    dwTimeCaptured: DWord; // see below
    dwUser: DWord; // user-specific data
    dwFlags: DWord; // see below
    dwReserved1, dwReserved2, dwReserved3: DWord; // reserved; do not use
  end;

  TVIDEOHDRPtr = ^TVIDEOHDR;

  DWordDim = array [1 .. PICWIDTH] of DWord;

  TForm1 = class(TForm)
    Timer1: TTimer;
    Panel1: TPanel;
    Panel2: TPanel;
    Button1: TButton;
    // Panel1: TPanel;
    // Timer1: TTimer;
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    FCapHandle: THandle;
    FCodec: TVideoCodec;
    FBuf1, FBuf2: array [1 .. PICHEIGHT] of DWordDim;
    FBitmap: TBitmap;
    FJpeg: TJPegImage;
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
function capCreateCaptureWindow(lpszWindowName: LPCSTR; dwStyle: DWord;
  x, y, nWidth, nHeight: integer; hwndParent: HWND; nID: integer): HWND;
  stdcall; external 'AVICAP32.DLL' name 'capCreateCaptureWindowA';

function FrameCallbackFunction(AHandle: HWND; VIDEOHDR: TVIDEOHDRPtr): bool;
  stdcall;
var
  I: integer;
begin
  result := true;

  with Form1 do
  begin
    try
      ConvertCodecToRGB(FCodec, VIDEOHDR^.lpData, @FBuf2, PICWIDTH, PICHEIGHT);

      for I := 1 to PICHEIGHT do
        FBuf1[I] := FBuf2[PICHEIGHT - (I - 1)];
      SetBitmapBits(FBitmap.Handle, PICWIDTH * PICHEIGHT * SizeOf(DWord),
        @FBuf1);

      FBitmap.Canvas.Brush.Color := clWhite;
      FBitmap.Canvas.Font.Color := clRed;

      FJpeg.Assign(FBitmap);

      FJpeg.CompressionQuality := 85;
      FJpeg.ProgressiveEncoding := true;
      FJpeg.SaveToFile('c:\webcam.jpg');

      SendMessage(FCapHandle, WM_CAP_SET_CALLBACK_FRAME, 0, 0);
    except
    end;
  end;
end;

// ------------------------------------------------------------------------------

procedure TForm1.FormCreate(Sender: TObject);
var
  BitmapInfo: TBitmapInfo;
begin
  self.Position := poScreenCenter;
  Timer1.Enabled := false;

  FBitmap := TBitmap.Create;
  FBitmap.Width := PICWIDTH;
  FBitmap.Height := PICHEIGHT + SUBLINEHEIGHT + EXTRAHEIGHT;
  FBitmap.PixelFormat := pf32Bit;
  FBitmap.Canvas.Font.Assign(Panel1.Font);
  FBitmap.Canvas.Brush.Style := bssolid;
  FBitmap.Canvas.Rectangle(0, PICHEIGHT, PICWIDTH, PICHEIGHT + SUBLINEHEIGHT);

  FJpeg := TJPegImage.Create;

  FCapHandle := capCreateCaptureWindow('Video', WS_CHILD or WS_VISIBLE, 0, 0,
    PICWIDTH, PICHEIGHT, Panel1.Handle, 1);
  SendMessage(FCapHandle, WM_CAP_DRIVER_CONNECT, 0, 0);
  SendMessage(FCapHandle, WM_CAP_SET_PREVIEWRATE, 15000, 0);
  SendMessage(FCapHandle, WM_CAP_SET_OVERLAY, 1, 0);
  SendMessage(FCapHandle, WM_CAP_SET_PREVIEW, 1, 0);

  // SendMessage(FCapHandle, WM_CAP_DLG_VIDEOFORMAT,1,0);

  FillChar(BitmapInfo, SizeOf(BitmapInfo), 0);
  SendMessage(FCapHandle, WM_CAP_GET_VIDEOFORMAT, SizeOf(BitmapInfo),
    integer(@BitmapInfo));
  FCodec := BICompressionToVideoCodec(BitmapInfo.bmiHeader.biCompression);
  if FCodec <> vcUnknown then
  begin
    Timer1.Enabled := true;
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FBitmap.Free;
  FJpeg.Free;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
//  self.Caption := inttostr(self.Width) + '  ' + inttostr(self.Height);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  // 不知道怎麼寫
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  if FCodec = vcUnknown then
    showMessage('unknown compression');
  FBitmap.Height := PICHEIGHT + SUBLINEHEIGHT;

  self.Width := 658;
  self.Height := 575;
  self.Caption := 'WebCam取得影像小幫手';

end;

// ------------------------------------------------------------------------------

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  SendMessage(FCapHandle, WM_CAP_SET_CALLBACK_FRAME, 0,
    integer(@FrameCallbackFunction));
  SendMessage(FCapHandle, WM_CAP_GRAB_FRAME_NOSTOP, 1, 0);
  // ist hintergrundlauffähig

end;

end.
